function Create(self)
	--The higher the number, the slower the board corrects itself, 1 being not at all and 0 being always upright.
	self.rotsoftness = 0.7;
end

function Destroy(self)
end

function Update(self)
	local water = false
	if WaterHeight ~= nil then
		water = true
	end
	
	--If underwater, do something cool.
	if water == true and self.Pos.Y + self.Vel.Y > WaterHeight then	
		if self:GetController():IsState(Controller.MOVE_RIGHT) and self:GetController():IsState(Controller.BODY_CROUCH) then
			self.Vel.X = self.Vel.X + 0.4;
		end
		if self:GetController():IsState(Controller.MOVE_LEFT) and self:GetController():IsState(Controller.BODY_CROUCH) then
			self.Vel.X = self.Vel.X - 0.4;
		end
		if self:GetController():IsState(Controller.AIM_SHARP) and self:GetController():IsState(Controller.BODY_JUMP) then
			self.Vel.Y = self.Vel.Y - 0.5;
		end
		if self:GetController():IsState(Controller.AIM_SHARP) and self:GetController():IsState(Controller.BODY_CROUCH) then
			self.Vel.Y = self.Vel.Y + 0.35;
		end
	end
	
	--Auto-Allign own angle and keep upright. Extra control.
	--NOTE: Designed for keyboard only layout.
	if self:GetController():IsMouseControlled() == false then
		if self:GetController():IsState(Controller.AIM_SHARP) then
			self.RotAngle = self.RotAngle * self.rotsoftness;
			self.AngularVel = self.AngularVel * self.rotsoftness;
			
			--Slow down midair for more control.
			if self.Vel.X < 0 then
				--If we're going left (negative numbers), add the deceleration so we slow down.
				self.Vel.X = self.Vel.X + 0.35;
				--Again, we cap off the speed in case it went too far.
				if self.Vel.X > 0 then
					self.Vel.X = 0;
				end
			else
				--If we're going right (positive numbers), subtract the deceleration so we slow down.
				self.Vel.X = self.Vel.X - 0.35;
				if self.Vel.X < 0 then
					self.Vel.X = 0;
				end
			end	
		end
	else
	--UPDATE: Now for mouse users! Except that they need to press left and right together to do this.
		if self:GetController():IsState(Controller.MOVE_LEFT) and self:GetController():IsState(Controller.MOVE_RIGHT) then
			self.RotAngle = self.RotAngle * self.rotsoftness;
			self.AngularVel = self.AngularVel * self.rotsoftness;
			
			--Slow down midair for more control.
			if self.Vel.X < 0 then
				--If we're going left (negative numbers), add the deceleration so we slow down.
				self.Vel.X = self.Vel.X + 0.35;
				--Again, we cap off the speed in case it went too far.
				if self.Vel.X > 0 then
					self.Vel.X = 0;
				end
			else
				--If we're going right (positive numbers), subtract the deceleration so we slow down.
				self.Vel.X = self.Vel.X - 0.35;
				if self.Vel.X < 0 then
					self.Vel.X = 0;
				end
			end	
		end
	end
end