function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.actionmode = 0; -- 0 is nothing, 1 is hook launched and trying to latch, 2 is terrain latched, 3 is object latched
	self.clingpos = Vector(0,0);
	self.canrelease = false;
	self.setlinelength = 0;
	self.curdist = 0;
	self.lastsetlinelength = 0;
	self.curvector = Vector(0,0);
	self.lastgunvel = Vector(0,0);
	self.taptimer = Timer();
	self.tapcounter = 0;
	self.didtap = false;
	self.cantap = false;
	self.lastvel = Vector(0,0);

	self.stickpositionX = 0;
	self.stickpositionY = 0;
	self.stickrotation = 0;
	self.stickdirection = 0;

------------------------------
----- Settings

	self.maxlinelength = 500; -- maximum length of grappling gun rope (in pixels)
	self.taptime = 200; -- maximum amount of time between tapping for claw to return
	self.tapamount = 3; -- how many times to tap to bring back rope

	self.mouseclimbinterval = 4; -- how many pixels the rope retracts/extends at a time for mouse users
	self.keyboardclimbinterval = 1; -- how many pixels the rope retracts/extends at a time for keyboard users

-----
------------------------------

	self.guncurdist = 30;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		self.gun = MovableMan:GetMOFromID(i);
		if self.gun.PresetName == "Aquanauts Spear Gun" and self.gun.ClassName == "HDFirearm" and (self.gun.Pos-self.Pos).Magnitude < self.guncurdist then
			self.actor = MovableMan:GetMOFromID(self.gun.RootID);
			if MovableMan:IsActor(self.actor) then
				self.parent = ToActor(self.actor);
				self.parentgun = ToHDFirearm(self.gun);
				self.lastgunvel = Vector(self.parentgun.Vel.X,self.parentgun.Vel.Y);
				self.Vel = self.parent.Vel + Vector(40,0):RadRotate(self.parent:GetAimAngle(true));
				self.actionmode = 1;

				for i = 1,MovableMan:GetMOIDCount()-1 do
					self.part = MovableMan:GetMOFromID(i);
					if self.part.RootID == self.parentgun.RootID and self.part.PresetName == "Waterproof Aquanauts Spear Gun Attachment Claw" then
						self.clawatta = ToAttachable(self.part);
						self.clawatta.Scale = 0;
					end
				end

			end
		end
	end

	if not(MovableMan:IsActor(self.parent)) then
		self.ToDelete = true;
	end

end

function Update(self)
	self.ToDelete = false;
	self.ToSettle = false;
	self:NotResting();

	if MovableMan:IsActor(self.parent) and self.parentgun ~= nil and self.parentgun.ID ~= 255 and self.parent:HasObject("Aquanauts Spear Gun") then

		if not(MovableMan:IsParticle(self.cranksound)) then
			self.cranksound = CreateAEmitter("Aquanauts Spear Gun Sound Crank","Aquanauts.rte");
			self.cranksound.Pos = self.parent.Pos;
			MovableMan:AddParticle(self.cranksound);
		elseif MovableMan:IsParticle(self.cranksound) then
			self.cranksound.Pos = self.parent.Pos;
			self.cranksound.ToDelete = false;
			self.cranksound.ToSettle = false;
			self.cranksound.PinStrength = 1000;
		end

		self.curvector = SceneMan:ShortestDistance(self.parent.Pos,self.Pos,self.mapwrapx);
		self.curdist = self.curvector.Magnitude;

		for i = 1, math.floor(self.curdist/10) do
			self.ropepar = CreateMOSRotating("Waterproof Aquanauts Spear Gun Rope","Aquanauts.rte");
			self.ropepar.Pos = self.Pos + Vector(-(i*10),0):RadRotate(self.curvector.AbsRadAngle);
			self.ropepar.RotAngle = self.curvector.AbsRadAngle;
			MovableMan:AddParticle(self.ropepar);
		end

		if not(self.parent:GetController():IsState(Controller.WEAPON_FIRE)) then
			if self.actionmode == 1 then
				self.ToDelete = true;
			else
				self.canrelease = true;
			end
		elseif self.parent:GetController():IsState(Controller.WEAPON_FIRE) then
			if self.canrelease == true and (Vector(self.parentgun.Vel.X,self.parentgun.Vel.Y) ~= self.lastgunvel or self.parentgun:IsActivated() == true) then
				self.ToDelete = true;
			end
		end

		self.lastgunvel = Vector(self.parentgun.Vel.X,self.parentgun.Vel.Y);

--------------------------------------------------
		if self.actionmode == 2 or self.actionmode == 3 then
--------------------------------------------------

			if MovableMan:IsParticle(self.cranksound) then
				if self.lastsetlinelength ~= self.setlinelength then
					self.cranksound:EnableEmission(true);
				else
					self.cranksound:EnableEmission(false);
				end
			end

			self.lastsetlinelength = self.setlinelength;

			if self.parent:GetController():IsState(Controller.BODY_CROUCH) then

				if self.cantap == true then
					self.taptimer:Reset();
					self.didtap = true;
					self.cantap = false;
					self.tapcounter = self.tapcounter + 1;
				end

				if self.parent:GetController():IsMouseControlled() == true then
					self.parent:GetController():SetState(Controller.WEAPON_CHANGE_NEXT,false);
					self.parent:GetController():SetState(Controller.WEAPON_CHANGE_PREV,false);
					if self.parent:GetController():IsState(Controller.SCROLL_UP) and self.setlinelength > self.mouseclimbinterval then
						self.setlinelength = self.setlinelength - self.mouseclimbinterval;
					end
					if self.parent:GetController():IsState(Controller.SCROLL_DOWN) and self.setlinelength < (self.maxlinelength-self.mouseclimbinterval) then
						self.setlinelength = self.setlinelength + self.mouseclimbinterval;
					end
				elseif self.parent:GetController():IsMouseControlled() == false then
					if self.parent:GetController():IsState(Controller.HOLD_UP) and self.setlinelength > self.keyboardclimbinterval then
						self.setlinelength = self.setlinelength - self.keyboardclimbinterval;
					end
					if self.parent:GetController():IsState(Controller.HOLD_DOWN) and self.setlinelength < (self.maxlinelength-self.keyboardclimbinterval) then
						self.setlinelength = self.setlinelength + self.keyboardclimbinterval;
					end
				end

			elseif not(self.parent:GetController():IsState(Controller.BODY_CROUCH)) then
				self.cantap = true;
			end

			if self.taptimer:IsPastSimMS(self.taptime) then
				self.tapcounter = 0;
			elseif not(self.taptimer:IsPastSimMS(self.taptime)) then
				if self.tapcounter >= self.tapamount then
					self.ToDelete = true;
				end
			end

--------------------------------------------------
		end
--------------------------------------------------

----------------------------------------------------------------------------------------------------
		if self.actionmode == 1 then
----------------------------------------------------------------------------------------------------

			self.objectdetect = SceneMan:CastMORay(self.Pos,Vector(10,0):RadRotate(self.Vel.AbsRadAngle),self.parent.ID,0,false,0);
			if self.objectdetect ~= 255 then
				self.target = MovableMan:GetMOFromID(self.objectdetect);
				self.stickpositionX = self.Pos.X-self.target.Pos.X;
				self.stickpositionY = self.Pos.Y-self.target.Pos.Y;
				self.stickrotation = self.target.RotAngle;
				self.stickdirection = self.RotAngle;
				local hitsound = CreateAEmitter("Aquanauts Spear Gun Sound Stick","Aquanauts.rte");
				hitsound.Pos = self.Pos;
				MovableMan:AddParticle(hitsound);
				self.setlinelength = math.floor(self.curdist);
				self.Vel = Vector(0,0);
				self.PinStrength = 1000;
				self.Frame = 1;
				self.actionmode = 3;
			elseif SceneMan:CastStrengthRay(self.Pos,Vector(12,0):RadRotate(self.Vel.AbsRadAngle),0,self.clingpos,0,0,self.mapwrapx) == true then
				local hitsound = CreateAEmitter("Aquanauts Spear Gun Sound Stick","Aquanauts.rte");
				hitsound.Pos = self.Pos;
				MovableMan:AddParticle(hitsound);
				self.setlinelength = math.floor(self.curdist);
				self.Vel = Vector(0,0);
				self.PinStrength = 1000;
--				self.Pos = self.clingpos;
				self.Frame = 1;
				self.actionmode = 2;
			end
			if self.curdist > self.maxlinelength then
				self.ToDelete = true;
			end

----------------------------------------------------------------------------------------------------
		elseif self.actionmode == 2 then
----------------------------------------------------------------------------------------------------

			if self.curdist > self.setlinelength then
--[[
				self.movetopos = self.Pos + (self.curvector*-1):SetMagnitude(self.setlinelength);
				if self.mapwrapx == true then
					if self.movetopos.X > SceneMan.SceneWidth then
						self.parent.Pos = Vector(self.movetopos.X - SceneMan.SceneWidth,self.movetopos.Y);
					elseif self.movetopos.X < 0 then
						self.parent.Pos = Vector(SceneMan.SceneWidth + self.movetopos.X,self.movetopos.Y);
					else
						self.parent.Pos = self.movetopos;
					end
				else
					self.parent.Pos = self.movetopos;
				end
--]]
				self.pullamountnumber = self.curvector.AbsRadAngle-self.parent.Vel.AbsRadAngle;
				if self.pullamountnumber < 0 then
					self.pullamountnumber = self.pullamountnumber * -1;
				end
				self.pullamountnumber = self.pullamountnumber/(math.pi*2);
				self.parent:AddAbsForce(self.curvector:SetMagnitude(  ((self.curdist - self.setlinelength)^4)*self.pullamountnumber  ),self.parent.Pos);

			end

----------------------------------------------------------------------------------------------------
		elseif self.actionmode == 3 then
----------------------------------------------------------------------------------------------------

			if MovableMan:IsActor(self.target) or MovableMan:IsDevice(self.target) or MovableMan:IsParticle(self.target) or self.target.ID ~= 255 then

				self.Pos = self.target.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.target.RotAngle-self.stickrotation);
				self.RotAngle = self.stickdirection+(self.target.RotAngle-self.stickrotation);
				if self.curdist > self.setlinelength then

					self.pullamountnumber = self.curvector.AbsRadAngle-self.parent.Vel.AbsRadAngle;
					if self.pullamountnumber < 0 then
						self.pullamountnumber = self.pullamountnumber * -1;
					end
					self.pullamountnumber = self.pullamountnumber/(math.pi*2);
					self.parent:AddAbsForce(self.curvector:SetMagnitude(  ((self.curdist - self.setlinelength)^3)*self.pullamountnumber  ),self.parent.Pos);

					self.pullamountnumber = (self.curvector*-1).AbsRadAngle-(SceneMan:ShortestDistance(Vector(self.lastvel.X,self.lastvel.Y),Vector(self.Pos.X,self.Pos.Y),self.mapwrapx)).AbsRadAngle;
					if self.pullamountnumber < 0 then
						self.pullamountnumber = self.pullamountnumber * -1;
					end
					self.pullamountnumber = self.pullamountnumber/(math.pi*2);
					self.target:AddAbsForce((self.curvector*-1):SetMagnitude(  ((self.curdist - self.setlinelength)^3)*self.pullamountnumber  ),self.Pos);

					--NEW! Pulling while attached to target will cause DAMAGE!
					if self.target.Mass < 60 and self.parent:GetController():IsState(Controller.BODY_CROUCH) and self.parent:GetController():IsState(Controller.HOLD_UP) and self.parent:GetController():IsState(Controller.BODY_JUMP) then
						--RIP AND TEAR!!!
						self.target.ToDelete = true; --gibbing nor health didnt work. Deleting is the way to go.
						self.ToDelete = true;
						--end
					end
					
					self.lastvel = Vector(self.Pos.X,self.Pos.Y);

				end
				

				
			else
				self.ToDelete = true;
			end

----------------------------------------------------------------------------------------------------
		end
----------------------------------------------------------------------------------------------------
	else
		self.ToDelete = true;
	end
	

end

function Destroy(self)

	if self.clawatta ~= nil and self.clawatta.ID ~= 255 then
		self.clawatta.Scale = 1;
	end

	if MovableMan:IsParticle(self.cranksound) then
		self.cranksound.ToDelete = true;
	end

end